<!DOCTYPE html>
<html>
<head>
<meta charset="UTF-8"/>
<title>Évènements</title>
<link rel="stylesheet" type="text/css" href="stylesheet.css"/>

<script type="text/javascript" src="md5.js"></script>

<script type="text/javascript">
// GLOBALS
var url = window.location.href;
var host = window.location.origin;
let pathname = window.location.pathname;
var path = pathname.substring(0, pathname.lastIndexOf('/')+1);
var script = 'server.php';
var server = host + path + script;


// FETCH
// envoie data à l'url et retourne la réponse 
async function post_data(url, data) {
	//console.log('fetching from "'+url+'"...');
	const response = await fetch(url, {
		method: 'POST',
		mode: 'cors',
		cache: 'no-cache',
		credentials: 'omit',
		redirect: 'follow',
		referrer: 'no-referrer',
		body: JSON.stringify(data)
	});
	//console.log('fetched! parsing...');
	/*let text = await response.text();
	console.log(text);*/
	let res = await response.json(); // JSON to js object
	//console.log('parsing is done!');
	return res;
}


// COOKIES
function setCookie(name, value, days = 1) {
	let expires = "";
	if(days) {
		var date = new Date();
		date.setTime(date.getTime() + (days*24*60*60*1000));
		expires = "; expires=" + date.toUTCString();
	}
	document.cookie = name + "=" + (value || "")  + expires + "; path=/";
}

function getCookie(name) {
	let nameEQ = name + "=";
	let ca = document.cookie.split(';');
	for(let i=0; i<ca.length; i++) {
		let c = ca[i];
		while(c.charAt(0) == ' '){
			c = c.substring(1, c.length);
		}
		if(c.indexOf(nameEQ) == 0) {
			return c.substring(nameEQ.length, c.length);
		}
	}
	return null;
}

function eraseCookie(name) {   
	document.cookie = name + '=; Max-Age=-99999999;';
}


// MISE EN PAGE DES RÉSULTATS
// prend une ligne du résultat de la requête et la transforme en <div>
function row_to_event(row) {
	let champs = ['titre', 'theme', 'description', 'contact', 'note', 'nb_notes', 'debut', 'fin', 'public', 'effectif_min', 'effectif_max'];

	let res = document.createElement('div');
	res.className = 'events';
	res.setAttribute('data-EID', row['EID']);

	for(let col of champs) {
		if(row[col] !== null){
			let element;

			switch(col) {
			case 'titre':
				element = document.createElement('h3');
				element.innerHTML = row[col];
				break;

			case 'description':
				element = document.createElement('p');
				element.innerHTML = row[col];
				break;

			case 'contact':
				element = document.createElement('div');
				element.innerHTML = 'Contact : '+row[col];
				break;

			case 'note':
				if(row['nb_note'] == 0)
					break;
				element = document.createElement('div');
				element.innerHTML = 'Noté '+row[col]+'/10';
				break;

			case 'nb_notes':
				if(row['note'] === null || row['nb_note'] == 0)
					break;
				element = document.createElement('div');
				element.innerHTML = ' par '+row[col]+' utilisateurs';
				break;
			
			case 'public':
				element = document.createElement('div');
				element.innerHTML = 'Public : '+row[col];
				break;

			case 'effectif_min':
				element = document.createElement('div');
				element.innerHTML = 'Effectif minimum : '+row[col];
				break;

			case 'effectif_max':
				element = document.createElement('div');
				element.innerHTML = 'Effectif maximum : '+row[col];
				break;

			default:
				element = document.createElement('div');
				element.innerHTML = row[col];
			}

			element.className = col;
			res.appendChild(element);
		}
	}

	if(getCookie('user_id') !== null) {
		let access = document.createElement('input');
		access.type = 'button';
		access.className = 'event_button';
		access.value = 'S\'inscrire';
		access.addEventListener('click',
			// inscription à un évènement
			function inscription_event() {

			let event_id = this.parentNode.getAttribute('data-EID');
			let user_id = getCookie('user_id');

			if(user_id == null) {
				alert('Il faut être connecté pour s\'inscrire à un évènement');
				window.location.reload(true);
			}

			let query = {
				'type': 'call',
				'procedure': 'inscription_event',
				'parameters': {
					'EID': event_id,
					'UID': user_id
				}
			};

			post_data(server, query)
			.then(res => {
				if(res['error']) {
					alert(res['error']);
					return;
				}

				alert('Inscription à l\'évènement réussie !');
			});
		});

		res.appendChild(access);
	}

	return res;
}

// récupère le résultat de la requête et rends une <div>
function display_events(result) {
	let contenu = document.getElementById('contenu');

	for(let row of result) {
		let event = row_to_event(row);
		contenu.appendChild(event);
		contenu.appendChild(document.createElement('hr'));
	}

	contenu.removeChild(contenu.lastChild);
}


// REQUETES
// recherche d'évènements
function search() {
	// cleanup
	let contenu = document.getElementById('contenu');
	let not_found = document.getElementById('not_found');
	while (contenu.lastChild != not_found) {
		contenu.removeChild(contenu.lastChild);
	}

	let champs = ['search_title', 'search_date', 'search_theme', 'search_public', 'search_note_min'];
	let parameters = {};

	for(let c of champs) {
		let value = document.getElementById(c).value || null;
		parameters[c] = value;
	}

	parameters['hide_full'] = (document.getElementById('hide_full').checked ? 1 : 0);

	let query = {
		'type': 'call',
		'procedure': 'events_by_criteria',
		'parameters': parameters
	};

	post_data(server, query)
	.then(res => {
		if(res['error']) {
			alert(res['error']);
			return;
		}

		let searcher = document.getElementById('searcher');
		let not_found = document.getElementById('not_found');

		if(res['result'].length == 0) {
			not_found.classList.remove('hidden');
			return;
		} else {
			not_found.classList.add('hidden');
			display_events(res['result']);
		}
	});
}
</script>
</head>

<body>
<div id="padding"></div>
<div id="searcher">
	<h3>Rechercher</h3>
	<form action="javascript:search()">
		<p> Titre :
			<input type="text" id="search_title">
		</p>

		<p> Date :
			<input type="date" id="search_date">
		</p>

		<p> Thème :
			<select id="search_theme">
				<option value="" selected></option>
			</select>
		</p>

		<p> Public :
			<select id="search_public">
				<option value="" selected></option>
				<option value="tous publics">Tous publics</option>
				<option value="enfants">Enfants</option>
				<option value="adultes">Adultes</option>
			</select>
		</p>

		<p> Note supérieure à : 
			<input type="number" id="search_note_min" min="0">
		</p>

		<p>
			<label> Montrer les évènements complets 
				<input type="checkbox" id="hide_full" checked>
			</label>
		</p>

		<input type="submit" value="Rechercher">
	</form>
</div>

<div id="contenu">
	<p id="not_found"> Aucun évènement trouvé :( </p>
</div>

<script type="text/javascript">
// ÉLÉMENTS DYNAMIQUES
// navbar
let navbar = document.createElement('div');
navbar.id = 'navbar';
navbar.className = 'navbar_elems';

let accueil = document.createElement('a');
let evenement = document.createElement('a');
let contribution = document.createElement('a');

accueil.className = evenement.className = contribution.className = navbar.className;

accueil.id = 'nb0';
evenement.id = 'nb1';
contribution.id = 'nb2';

accueil.href = './index.html';
evenement.href = './evenements.html';
contribution.href = './contribution.html';

accueil.innerHTML = 'Accueil';
evenement.innerHTML = 'Évènement';
contribution.innerHTML = 'Soumettre un évènement';

navbar.appendChild(accueil);
navbar.appendChild(evenement);
navbar.appendChild(contribution);

if(getCookie('user_id') != null) {
	let profil = document.createElement('a');
	profil.className = navbar.className;
	profil.id = 'nb3';
	profil.href = './profil.html';
	profil.innerHTML = 'Connecté en tant que ' + getCookie('pseudo');
	navbar.appendChild(profil);
	
	let disconnect = document.createElement('a');
	disconnect.className = navbar.className;
	disconnect.id = 'nb4';
	disconnect.innerHTML = 'Déconnexion';
	disconnect.onclick = function() {
		eraseCookie('user_id');
		eraseCookie('pseudo');
		eraseCookie('role');
		eraseCookie('contact');
		window.location.reload(true);
	}
	navbar.appendChild(disconnect);
}
else {
	let connect = document.createElement('a');
	connect.className = navbar.className;
	connect.id = 'nb3';
	connect.href = './connexion.html';
	connect.innerHTML = 'Connexion';
	navbar.appendChild(connect);

	let sign_in = document.createElement('a');
	sign_in.className = navbar.className;
	sign_in.id = 'nb4';
	sign_in.href = './inscription.html';
	sign_in.innerHTML = 'S\'inscrire';
	navbar.appendChild(sign_in);
}
document.body.insertBefore(navbar, document.body.firstChild);

// la date recherchée est aujourd'hui par défaut et au minimum
let search_date = document.getElementById('search_date');

post_data(server, 'now')
.then(now => {
	search_date.value = now['date'];
	search_date.min = search_date.value;
});

// population de la table thème
let query = {
	'type': 'call',
	'procedure': 'available_themes',
	'parameters': {}
};

post_data(server, query)
.then(res => {
	console.log('coucou')
	if(res['error']) {
		alert(res['error']);
		return;
	}

	let result = res['result'];
	let select = document.getElementById('search_theme');

	for(let r in result) {
		let option = document.createElement('option');
		option.innerHTML = result[r]['nom'];

		select.appendChild(option);
	}
});

// population des évènements
search();
</script>
</body>
</html>